/*
	Advanced coding macros by Catid@pacbell.net
*/

#ifndef MATH_H
#define MATH_H

#include "datatypes.h"
#include <stdlib.h>

Uint32 sqrt(Uint32 factor);	// Fast integer square root


Uint32 distance(Uint32 a, Uint32 b);	// 1D distance
Sint32 distance(Sint32 a, Sint32 b);	// 1D distance


Sint16 sgn(Sint16 a);	// Return the sign
Sint32 sgn(Sint32 a);	// Return the sign


Uint32 trim(Uint32 large, Uint32 little);	// Useful for clipping calcs
Uint16 trim(Uint16 large, Uint16 little);	// Useful for clipping calcs
Sint32 trim(Sint32 large, Sint32 little);	// Useful for clipping calcs
Sint16 trim(Sint16 large, Sint16 little);	// Useful for clipping calcs


Uint32 limit(Uint32 a, Uint32 max);	// Useful to avoid buffer overflows


void swap(void * &a, void * &b);	// Quick swap using XOR
void swap(Uint32 &a, Uint32 &b);	// Quick swap using XOR
void swap(Uint16 &a, Uint16 &b);	// Quick swap using XOR


Uint32 IMULHIDWORD(Uint32 A,
				   Uint32 B);	// Sort of like a modulus operator for multiplication


void IDIVCOMP(Uint32 value,
			  Uint32 width,
			  Uint32 &x,
			  Uint32 &y);	// Do division and modulus in the same step


void MEMCPY(void * src,void * dest,Uint32 len);	// Cut the Microsoft crap


Uint32 distance(Uint32 x1,
				Uint32 y1,
				Uint32 x2,
				Uint32 y2);	// d = sqrt((x1-x2)^2 + (y1-y2)^2)

Uint32 distancesqr(Uint32 x1,
				   Uint32 y1,
				   Uint32 x2,
				   Uint32 y2);	// dsqr = (x1-x2)^2 + (y1-y2)^2


Uint32 ROL(Uint32 x, Uint32 r);	// Emulate ROL opcode
Uint32 ROR(Uint32 x, Uint32 r);	// Emulate ROR opcode
Uint32 ROT(Uint32 x, Sint32 r);	// Negative numbers -> ROR, Positives -> ROL

#endif	//MATH_H
